Available in🇮🇳 India
Use Razorpay Turbo UPI to make UPI payments faster. Follow these steps to integrate with the Razorpay Turbo UPI Headless SDK.
Prerequisites
Prerequisites
- Integrate with the Razorpay Android Custom SDK.
-
Contact our Integrations team and provide the following details to get allowlisted:
- Mobile numbers of your internal users.
- App id of your debug, staging and production apps.
-
Contact our Integrations team to get the access to the Sample App Repository
https://github.com/upi-turbo/android-turbo-sample-app. Once you have access, please read the readme section of the repository to learn how to locate the library files and integrate them into your project. -
Add the following lines to your Android project’s
gradle.propertiesfile:android.enableJetifier=trueandroid.useAndroidX=true
-
The
minSDKversionfor using Turbo UPI is currently 23 and cannot be over written.
- In the root settings.gradle file, use:
Kotlin
- In the library module’s build.gradle, use:
Kotlin
1. Integration Steps
1.1 Create a Session Token
To enhance security, you must create a session token via a server-to-server (S2S) call between your backend and Razorpay’s backend. This session token ensures secure communication between the Turbo SDK and Razorpay’s systems.How to Create a Session Token
-
Trigger the S2S API from your Backend. Use the following API to generate a session token:
Environment based URLs:
-
UAT:
https://api-web-turbo-upi.ext.dev.razorpay.in -
Production:
https://api.razorpay.com
-
UAT:
Base64.encode(${public_key}:${secret})
Request Parameters
Request Parameters
customer_reference mandatory
: string A unique identifier for the customer provided by the business. The recommended value is mobile number. For example, 9000090000.Response Parameters
Response Parameters
token
: string A session token to be used in subsequent session-protected APIs.expire_at
: long Expiry time (in seconds) for the session token, used to optimise session handling and reduce unnecessary reinitialisations.error
: object The request failure due to business or technical failure.1.2 Initialise Turbo SDK
Initialise theTurboSessionDelegate object anonymously and pass it through the initialize method. The SDK will call fetchToken function whenever required to get new token. In the
fetchToken function, retrieve a new token from your server section, check 1.1 Create a Session Token. Once available, pass it to the completion object.
1.3 Getting Linked UPI Accounts
After initialising the Turbo SDK, proceed to securely link UPI accounts and complete the payment flow.- Get already linked accounts. If your customer has already linked accounts, use the following code to fetch them. If there are no linked UPI accounts, an empty list is returned.
Handy Tips
- When the user arrives at your checkout screen, use the
getLinkedUpiAccountsfunction to fetch the updated list of UPI accounts. - For enhanced user experience mobile number is required in
getLinkedUpiAccountsfunction, otherwise feel free to use either mobile number or customer id.
Request Parameters
Request Parameters
customerMobile mandatory
: string The customer’s mobile number.listener
: object The listener to be sent should be of type UpiTurboResultListener.Response Parameters
Response Parameters
onSuccess
: This function is triggered if the list is fetched successfully. accList can be empty to indicate that no accounts have been linked yet.onError
: This function is triggered in case an error is thrown during the retrieval process, either by the Razorpay SDK or the Bank SDK.1.4 New user onboarding / Linking additional accounts
Invoke the below function for these use cases:- To initiate new onboarding, in case you get a DEVICE_BINDING_INCOMPLETE error in the above section,
- To link additional bank accounts for already onboarded users.
Handy TipsA mobile number is required in the
linkNewUpiAccount function for an enhanced user experience. Otherwise, feel free to use either your mobile number or customer id.- Invoke the below function in your Activity’s
onRequestPermissionsResultfunction.
- Additionally
razorpay.onBackPressed()has to be invoked when a user tries to exit the app or return to the previous page. Therazorpay.upiTurbo.releaseActivityReference()function releases the allocated memory.
- To process the payment, first create a payload, which will be a
JSONObjectas shown in the code below.
- Pass the
upiAccountandpayloadobjects as shown in the code below.
Handy TipsIn case of an error response, you will get a nested
reason JSON object, which will contain the original error code and description from the bank/NPCI.Non-Transactional Flow
You can directly interact with the exposed methods of the Turbo Framework to perform the non-transactional flows listed below.Fetch Balance
Fetch Balance
Fetch the customer’s account balance. Call
getBalance() and pass the UpiAccount instance you have received from Turbo SDK before.Change UPI PIN
Change UPI PIN
Provide the customer the ability to change their UPI PIN. Call
changeUpiPin() and pass the upiAccount instance you have received from Turbo SDK before.Reset UPI
Reset UPI
Let your customers reset the PIN for their account. You will need to collect the below mentioned details for the account:
- Bank accounts: last 6 digits, expiry month & year of the Debit Card.
- Credit cards: last 6 digits, expiry month & year of the Credit Card.
Card data class provided by Turbo SDK and the upiAccount object you received from Turbo SDK.Delink
Delink
Let your customers delink, that is, remove a selected UPI account from your application.
Additional Features
- To get the device binding status, please use the method
isDeviceOnboarded()which returns a boolean. It indicates whether the device binding, which is a prerequisite for adding UPI accounts, is done with the user’s mobile number.
Kotlin
- Users can now link their credit cards alongside bank accounts during onboarding. You can seamlessly retrieve both credit and bank accounts for transactions, thereby simplifying payments, expanding options, and ensuring security.
- Changes have been made to the AccountBalance and UpiAccount models regarding credit card support on UPI.
- Charges will be levied for payments made using CC on UPI. Contact the support team for further information.
-
Turbo SDK will auto-select the SIM card in few cases and the
SELECT_SIMaction will not be triggered in such cases:- Device has only one SIM card.
- Device has multiple SIM cards and the mobile number provided by you matches the number on one of the SIM cards.
Action Parameter Values
Action Parameter Values
Following are the constants passed in the
action.code parameter in onResponse.Models Exposed from the SDKs
The SDKs given below provide access to exposed models for seamless integration.BankAccount
BankAccount
Bank
Bank
AccountBalance
AccountBalance
Error
Error
UpiAccount
UpiAccount
SIM
SIM
Card
Card
AllBanks
AllBanks
UpiTurbo.LinkAction
UpiTurbo.LinkAction
BankAccountState
BankAccountState
2. Test Integration
We recommend the following:- Complete the integration on UAT before using the prod builds.
- Perform the UAT using the Razorpay-provided API keys.
3. Go-live Checklist
Complete these steps to take your integration live:- You should get your app id whitelisted by Razorpay to test on prod.
- As a compliance requirement, you need to get approval from Google for READ_SMS permission. Refer to the Google article for more details.
-
Add Proguard rules:
keepclassmembers,allowobfuscation class * { @com.google.gson.annotations.SerializedName <fields>; }keepclassmembers enum * { *; }keepclassmembers class * { @android.webkit.JavascriptInterface <methods>; }dontwarn com.razorpay.**keep class com.razorpay.** {*;}keep class com.olivelib.** {*;}keep class com.olive.** {*;}keep class org.apache.xml.security.** {*;}keep interface org.apache.xml.security.** {*;}keep class org.npci.** {*;}keep interface org.npci.** {*;}keep class retrofit2.** { *; }keep class okhttp3.** { *; }
- Replace the UAT credential with the Razorpay live keys for prod testing.